Attribute VB_Name = "Module1"
Option Explicit

Declare Function AppendMenu Lib "user32" Alias _
"AppendMenuA" (ByVal hMenu As Long, ByVal wFlags _
As Long, ByVal wIDNewItem As Long, ByVal _
lpNewItem As String) As Long

Declare Function GetSystemMenu Lib "user32" _
(ByVal hWnd As Long, ByVal bRevert As Long) As Long

Declare Function SetWindowLong Lib "user32" _
Alias "SetWindowLongA" (ByVal hWnd As Long, _
ByVal nIndex As Long, ByVal dwNewLong As Long) As Long

Declare Function CallWindowProc Lib "user32" _
Alias "CallWindowProcA" (ByVal lpPrevWndFunc _
As Long, ByVal hWnd As Long, ByVal Msg As _
Long, ByVal wParam As Long, ByVal lParam As Long) As Long

Public Const WM_SYSCOMMAND = &H112
Public Const MF_SEPARATOR = &H800&
Public Const MF_STRING = &H0&
Public Const GWL_WNDPROC = (-4)
Public Const IDM_ABOUT As Long = 1010
Public Const IDM_PRINT As Long = 1011
Public Const IDM_SAVE As Long = 1012
Public lProcOld As Long
Public txtFilename As String



Public Function SysMenuHandler(ByVal hWnd _
As Long, ByVal iMsg As Long, ByVal wParam _
As Long, ByVal lParam As Long) As Long

If iMsg = WM_SYSCOMMAND Then
    If wParam = IDM_SAVE Then
      If txtFilename = "" Then
        txtFilename = "c:\mygraph.bmp"
      End If
      fSaveGuiToFile (txtFilename)
      Exit Function
    End If
    If wParam = IDM_PRINT Then
      Graph.MSChart1.EditCopy
      Printer.Print " "
      Printer.PaintPicture Clipboard.GetData(), 0, 0
      Printer.EndDoc
      Exit Function
    End If
    If wParam = IDM_ABOUT Then
      frmAbout.Show (1)
      Exit Function
    End If
End If

SysMenuHandler = CallWindowProc(lProcOld, _
hWnd, iMsg, wParam, lParam)
End Function

Public Function SubClass(FormName As Form)
Dim lhSysMenu As Long, lRet As Long

lhSysMenu = GetSystemMenu(FormName.hWnd, 0&)
lRet = AppendMenu(lhSysMenu, MF_SEPARATOR, 0&, vbNullString)
lRet = AppendMenu(lhSysMenu, MF_STRING, IDM_PRINT, "Print Graph")
lRet = AppendMenu(lhSysMenu, MF_STRING, IDM_SAVE, "Save Graph")
lRet = AppendMenu(lhSysMenu, MF_SEPARATOR, 0&, vbNullString)
lRet = AppendMenu(lhSysMenu, MF_STRING, IDM_ABOUT, "About...")

'FormName.Show (1)
lProcOld = SetWindowLong(FormName.hWnd, GWL_WNDPROC, AddressOf SysMenuHandler)
End Function

Public Function fSaveGuiToFile(ByVal theFile As String) As Boolean

'   Name:       fSaveGuiToFile
'   Author:     Dalin Nie
'   Written:    4/2/99
'   Purpose:
'       This procedure will Capture the Screen or the active window of your Computer and Save it as
'       a .bmp file

'   Input:
'       theFile   file Name with path, where you want the .bmp to be saved

'
'   Output:
'       True if successful
'

Dim lString As String

On Error GoTo Trap
'Check if the File Exist
    'If Dir(theFile) <> "" Then
    '  Deletefile (theFile)
    '
    'End If
Graph.MSChart1.EditCopy
SavePicture Clipboard.GetData(vbCFBitmap), theFile

fSaveGuiToFile = True
Exit Function

Trap:
'Error handling
MsgBox "Error Occured when Saving Graph Error #: " & Err.Number & ", " & Err.Description

End Function
